/*   H8/3052F Test Program   */
#include "3048f.h"

/* ================================================================== *
             $BDL?.ItJ,(B
 * ================================================================== */
$BN,(B:$B$3$N%W%m%0%i%`$K$OITMW$G$9$1$I!"2~B$$KLrN)$D$+$bCN$l$J$$$N$G;D$C$F$^$9!#(B
/* ================================================================== *
             $BDL?.ItJ,$3$3$^$G(B
 * ================================================================== */

/* ================================================================== *
             $B%9%F%C%T%s%0%b!<%?It(B
 * ================================================================== */

#define STEPC 4
unsigned char StepPattern[STEPC]=
{
  0x01,
  0x02,
  0x04,
  0x08,
};

int stepseq;  /* $B%9%F%C%W0LCV(B */

unsigned char GetStep(int dir)
{
  /* $B%9%F%C%W0LCVJQ99(B */
  if(dir>0) stepseq++;
  if(dir<0) stepseq--;
  /* $BN>C<@\B3(B */
  if(stepseq<0) stepseq=STEPC-1;
  if(stepseq>=STEPC) stepseq=0;
  return StepPattern[stepseq];
}


/* $B%W%m%0%i%`K\BN(B */
void main(void)
{
  int speed;
  int count;
  int i;
  unsigned char b;
  /* SCI $B=i4|2=(B */
  InitializeSCI();

  /* AD$B=i4|2=(B */
  AD.CSR.BYTE=0x33;  /* CH0-3$BO"B3JQ49(B */
  /* $BF~NOCM!'(BAD.DRA AD.DRB AD.DRC (AD.DRD>>6) 0-1023 */

  /* DA$B=i4|2=(B */
  DA.CR.BYTE=0xe0;        /* DA0,1 $BM-8z(B */
  /* $B=PNOCM!'(BDA.DR0 DA.DR1 0-255*/

  /* ITU$B=i4|2=(B ITU3,4 $B%Q%k%9I}B,Dj(B */
  ITU3.TIOR.BYTE=0x54;
  ITU3.TCR.BYTE=0x20;
  ITU4.TIOR.BYTE=0x54;
  ITU4.TCR.BYTE=0x20;
  ITU.TSTR.BYTE=0x18;

  /* $B%9%F%C%T%s%0%b!<%?$O(B P2 $B$K@\B3(B */
  P2.DDR=0x0f;
  
  count=0;
  while(1)
    {
      speed=P1.DR.BYTE;
      /* $B@)8B(B */
      if(speed>10000) speed=10000;
      if(speed<-10000) speed=-10000;
      /* DDS$B=hM}(B */
      if(count+speed>10000)  /* $B!\$K$"$U$l(B */
        {
          b=GetStep(+1);
          count=count+speed-10000;
        }
      else if(count+speed<-10000) /* $B!]$K$"$U$l(B */
        {
          b=GetStep(-1);
          count=count+speed+10000;
        }
      else
        {
          b=GetStep(0);
          count=count+speed;
        }
      P2.DR.BYTE=b;
      for(i=0;i<100;i++)  /* $B;~4V$D$V$7(B */
        ;
    }
}
